(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS
What's on This Disk
and How to Get Started
;[s]
2:0,0;18,1;61,-1;
2:1,37,27,Times,1,36,0,0,0;1,25,18,Times,1,24,0,0,0;
:[font = text; inactive; preserveAspect]
     This disk contains 14 Mathematica notebooks in addition to this one.  The two principal notebooks are DynSys1.ma and 
DynSys2.ma.  These contain (1) the Mathematica code for the all of the dynamical systems routines and (2) complete documentation for these routines.  The documentation is of three types.  In Part 1, an overview of the system is given in Section 2.  At the end of Part 2, there is an alphabetical index of the principal routines and variables.  Throughout the notebook where the code is presented, there is extensive annotation.  The code has been split into two notebooks just for convenience in handling.  Each notebook runs around 30 pages.  The other 12 notebooks are in the folder Tutorials.  These tutorials are designed to be an annotated introduction to the use of all of the routines.  It is strongly recommended that you work through at least the first one before beginning your own calculations.  Descriptions of the tutorials are given in Appendix A of Part 2.

     To get started, load Part 1 and evaluate the entire notebook, and then load Part 2 and evaluate the entire notebook.  After that, load Tutor1.ma and work through it step-by-step.  After working through it once, you may wish to go back through and experiment with your own choices of integration parameters, initial conditions, and plotting parameters.    	  
;[s]
5:0,0;27,1;38,0;158,1;169,0;1360,-1;
2:3,13,10,Courier,0,12,0,0,0;2,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
     This software has been tested on Macintoshes ranging from a IIci to Power PC's, all running Mathematica Versions 2.2.1 or 2.2.2.  In my brief experiments with mapping it over to the IBM-compatible environment, it seemed to run, but there were minor formatting problems with the text portions of the notebooks.
;[s]
3:0,0;97,1;108,0;315,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
     This software may be freely copied and distributed for any non-commercial use.
:[font = text; inactive; preserveAspect]
     Comments, suggestions, or bug reports will be received gratefully, and should be sent to me at the address below. 
:[font = text; inactive; preserveAspect; endGroup]
Al Clark
Department of Mechanical Engineering
University of Rochester
Rochester, NY 14627
716-275-4078
clark@me.rochester.edu
^*)
