(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 10
;[s]
1:0,1;30,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Bifurcation Sequences
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, bifurc, bifurc3D, boxrat, classify, classify2D, intreset, limbifurc, limbifurc3D, parmval, parmvec, plotreset, plrange, rangeflag, ranger, savesys, setparm, setstate, slopevec, statevec, sysid, and sysname.   
;[s]
2:0,1;47,0;270,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     In this tutorial, we construct sequences of phase portraits corresponding to a sequence of system parameter values.  As examples, we use two simple linear systems depending on a single parameter, and we use the van der Pol equation in both two and three dimensions.  The graph sequences produced, when animated, give a dynamic view of the bifurcations.     
;[s]
2:0,1;46,0;409,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Reference

     For a brief introduction to the van der Pol equation, see Nonlinear Dynamical Systems and Chaos, S.H. Strogatz, Addison-Wesley, 1994, Chapter 7.
;[s]
4:0,1;11,0;74,1;111,0;161,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Bifurcation Sequence for a 2D Linear System

     We define a simple linear system, with an equilbrium at 
x = y = 0, with the system depending on one parameter a.
;[s]
2:0,1;45,0;164,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{a}];
:[font = input; preserveAspect]
slopevec = {a*y, -x - 2*y};
:[font = input; preserveAspect]
sysname = "Linear2D";
:[font = text; inactive; preserveAspect]
     We look at the eigenvalues to determine the bifurcation points.
:[font = input; preserveAspect]
Eigenvalues[dermat]
:[font = text; inactive; preserveAspect]
It is not hard to show from the above formula that the bifurcation points are a = 0 and a = 1.  We use classify2D to verify this.
:[font = input; preserveAspect]
parmval = {-0.5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
parmval = {0.0};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
parmval = {0.5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
parmval = {1.0};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
parmval = {1.5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
Thus we have a transition from unstable to stable at a = 0 (a saddle-node bifurcation), and a transition from stable node to stable spiral at a = 1.  We now construct a sequence of phase portraits showing one of these transitions.  The routine which does this is bifurc.  The arguments of bifurc are a list of initial conditions intlist, the intial time t0, the time step h, the number of time steps nsteps, the components to be plotted (1 and 2 in this case), and the list parmlist of parameter values to be used.  For each set of parameter values in parmlist, the routine constructs a phase portrait using all the initial conditions in intlist. Although it is interesting to do a long sequence showing both transitions, this takes a lot of computer time, so for now we just look at the saddle node transition at a = 0.  We select five values of a centered on a = 0.   
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.1;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-2,2},{-2,2}};
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
ranger = plrange;
:[font = input; preserveAspect]
intlist = {{1,0},{1,1},{0,1},{-1,1},{-1,0},
		   {-1,-1},{0,-1},{1,-1}};
:[font = input; preserveAspect]
parmlist = {{-0.5},{-0.25},{0.0},{0.25},
			{0.50}};
:[font = input; preserveAspect]
bifurc[intlist,t0,h,nsteps,1,2,parmlist];
:[font = text; inactive; preserveAspect]
     By animating these graphs, you can get a dynamic view of the bifurcation sequence.
:[font = input; preserveAspect]
savesys[Linear2D];
:[font = text; inactive; preserveAspect]
Dependence of van der Pol Limit Cycle on Parameter - 2D

     We now use limbifurc to study how the van der Pol cycle changes with the damping parameter.  We define the system and set the integration and plotting parameters.  The routine that produces the sequence is limbifurc.  The arguments of limbifurc are an initial vector ivec (chosen close to the cycle if that information is available), the initial time t0, the time step h, the number of time steps nsteps, the components to be plotted 1 and 2, and the list of parameter values mulist. 
;[s]
2:0,1;57,0;547,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{mu}];
:[font = input; preserveAspect]
slopevec = {y, -x -mu*(x*x-1)*y};
:[font = input; preserveAspect]
parmval = {1};
:[font = input; preserveAspect]
sysname = "vanderPol";
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-4.0,4.0},{-4.0,4.0}};
:[font = input; preserveAspect]
mulist = {{0.0},{0.5},{1.0},{1.5},{2.0}};
:[font = input; preserveAspect]
ivec = {2.0,0.0};
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 250;
:[font = input; preserveAspect]
limbifurc[ivec,t0,h,nsteps,1,2,mulist];
:[font = text; inactive; preserveAspect]
     By animating these graphs, you can get some idea of the continuous change of the cycle as the parameter increases.
:[font = input; preserveAspect]
savesys[vanderPol];
:[font = text; inactive; preserveAspect]
Bifurcation Sequence for a 3D Linear System

     We consider here a simple linear system which goes through a saddle-node transition.  We produce this system by embedding our earlier 2D system in 3D, by adding a "stable" z-equation.  The bifurcations occur at the same a-values as before.  Here again we just look at the saddle-node bifurcation at a = 0.
;[s]
2:0,1;45,0;356,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{a}];
:[font = input; preserveAspect]
slopevec = {a*y, -x - 2*y,-z};
:[font = input; preserveAspect]
sysname = "Linear3D";
:[font = text; inactive; preserveAspect]
     We verify the character of the equilibrium for several a values.
:[font = input; preserveAspect]
parmval = {-0.5};
:[font = input; preserveAspect]
classify[{0,0,0}]
:[font = input; preserveAspect]
Eigenvalues[dermatval[{0,0,0}]]
:[font = text; inactive; preserveAspect]
     Thus for a = -0.5 we have a saddle with a two-dimensional stable manifold and a one-dimensional unstable manifold.
:[font = input; preserveAspect]
parmval = {0.5};
:[font = input; preserveAspect]
classify[{0,0,0}]
:[font = input; preserveAspect]
Eigenvalues[dermatval[{0,0,0}]]
:[font = text; inactive; preserveAspect]
     The saddle is now a stable node.  We illustrate the transition by using bifurc3D with 8 initial conditions and 5 parameter values.  (A more interesting sequence can be obtained with more parameter values, more closely spaced, but the calculations take a long time and much memory.)  After the graphs are constructed, select them and then choose from the Graph Menu the command Animate Selected Graphics. 
:[font = input; preserveAspect]
plrange = {{-2,2},{-2,2},{0,1}};
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
ranger = plrange;
:[font = input; preserveAspect]
intlist = {{1,0,1},{1,1,1},{0,1,1},{-1,1,1},{-1,0,1},
		   {-1,-1,1},{0,-1,1},{1,-1,1}};
:[font = input; preserveAspect]
parmlist = {{-0.5},{-0.25},{0.0},{0.25},
			{0.50}};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.1;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
bifurc3D[intlist,t0,h,nsteps,1,2,3,parmlist];
:[font = text; inactive; preserveAspect]
Dependence of van der Pol Limit Cycle on Parameter -- 3D

     To illustrate the use of limbifurc3D in the construction of a sequence of limit cycles formed from a sequence of parameter values, we use a version of the van der Pol system.  This version was constructed by first embedding the 2D x-y system in 3D, by adding an exponential decay in the third dimension -- dz/dt = -z.  Then the system was rotated 45 degrees about the x-axis.  The resulting system is defined below.
;[s]
2:0,1;58,0;479,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{mu}];
:[font = input; preserveAspect]
slopevec = {y/2^(1/2) + z/2^(1/2), -(x/2^(1/2)) + 
 
   (1/2 - (mu*(-1 + x^2))/2)*y + (-1/2 - (mu*(-1 + x^2))/2)*z
 
   , -(x/2^(1/2)) + (-1/2 - (mu*(-1 + x^2))/2)*y + 
 
   (1/2 - (mu*(-1 + x^2))/2)*z};
:[font = text; inactive; preserveAspect]
     Next we set the plotting variables.
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
plrange = {{-3,3},{-3,3},{-3,3}};
:[font = input; preserveAspect]
sysname = "van3D"; 
:[font = text; inactive; preserveAspect]
     We look at five values of the parameter mu. 
:[font = input; preserveAspect]
parmlist = {{0.0},{0.5},{1.0},{1.5},{2.0}};
:[font = input; preserveAspect]
initvec = {2,0,0};
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 200;
:[font = text; inactive; preserveAspect]
     Now we call limbifurc3D, which produces a limit cycle for each parameter list in parmlist.  After the graphs are constructed, select them and animate them to get a dynamica view of the change of the cycle shape with parameter.
:[font = input; preserveAspect]
limbifurc3D[initvec,t0,h,nsteps,1,2,3,parmlist];
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Consider the two-dimensional autonomous system given by   dx/dt = a*x - x^3, dy/dt = -y.  (The system is artificially simple but is a prototype for more complicated nonlinear systems with similar behavior.  The system has what is known as a pitchfork bifurcation at a = 0.)  Show that this system has one equilibrium point for a<0 and three equilibria for a>0.  Find the stability of the equilibria in all cases.  Use bifurc to study the dependence of the solutions on the parameter a.   
;[s]
2:0,1;10,0;504,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
