(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 12
;[s]
1:0,1;30,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Lorenz Equations
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, boxrat, classify, dermatval, dival,eqstateval, fastflag, findpolyeq, integrate, intreset, joinsol, lastt, lastx,  parmval, parmvec, phaseplot, phaser3D, plotreset, plrange, portrait3D, rangeflag, ranger, setparm, setstate, show3D, slopevec, staterange, statevec, sysid, sysname, and timeplot.   
;[s]
2:0,1;47,0;356,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     In this tutorial, we look at some of the interesting features of solutions of Lorenz equations.  The mode is not that of exploration, but rather verification and visualization of some results that are known for these equations.  The three parameters of the Lorenz equations are sigma, r, and b.  Here we take the frequently used values of sigma = 10.0 and b = 8/3, and then look at properties of the solutions for selected values of r.  
;[s]
2:0,1;46,0;489,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
References

     For a basic treatment of the Lorenz equations, see Chapter 9 of Nonlinear Dynamics and Chaos, S.H. Strogatz, Addison-Wesley, 1994.  For a general work containing a more advanced treatment, see Nonlinear Oscillations, Dynamical Systems, and Bifurcations of Vector Fields, J. Guckenheimer and P. Holmes, Springer-Verlag, 1983.  For a book-length treatment containing many detailed results, see The Lorenz Equations:  Bifurcations, Chaos, and Strange Attractors, C. Sparrow, Springer-Verlag, 1982.  For some historical perspective on the discovery of the Lorenz equations, see The Essence of Chaos, E.N. Lorenz, University of Washington Press, 1993.   
;[s]
10:0,1;10,0;81,1;109,0;210,1;286,0;409,1;475,0;591,1;611,0;667,-1;
2:5,13,10,Courier,0,12,0,0,0;5,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We denote the three state variables of the Lorenz system by x, y, and z.  The parameters of the system are sigma, r, and b.  For now, we leave these as symbols, by setting parmval to the symbols.  When we do use numerical values, we will take sigma = 10.0 and b = 8/3 throughout.    
;[s]
2:0,1;19,0;308,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = input; preserveAspect]
sysname = "Lorenz";
:[font = input; preserveAspect]
parmval = {sigma,r,b};
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = text; inactive; preserveAspect]
The Range 0 < r < 1.

     We begin by looking for equilibrium points.
;[s]
2:0,1;22,0;71,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
eqpoints = findpolyeq
:[font = text; inactive; preserveAspect]
     We see that for this range of r, there is a single real equilibrium at the origin, but for r values greater than 1, there are three real equilibria.  We will need all three eventually, so we name them now:  
:[font = input; preserveAspect]
C0 = eqpoints[[1]]
:[font = input; preserveAspect]
C1 = eqpoints[[2]]
:[font = input; preserveAspect]
C2 = eqpoints[[3]]
:[font = text; inactive; preserveAspect]
     Now we take the standard values for sigma and b, and a typical value for r in this range.
:[font = input; preserveAspect]
parmval = {10.0,0.5,8/3};
:[font = text; inactive; preserveAspect]
     We examine the stability of the equilibrium at the origin by calculating the eigenvalues.
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = text; inactive; preserveAspect]
     Thus we have a stable node.  It is possible to show that for the r-range (0,1) this node is a global attractor for the system.  We use portrait3D to construct a simple phase portrait.  
:[font = input; preserveAspect]
intlist = {{5,5,10},{5,-5,10},{-5,-5,10},{-5,5,10},
			{0,5,10},{5,0,10},{-5,0,10},{0,-5,10}};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.015;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5},{0,10}};
:[font = input; preserveAspect]
portrait3D[intlist,t0,h,nsteps,1,2,3];
:[font = text; inactive; preserveAspect]
The Pitchfork Bifurcation at r = 1.

     For r < 1, there is one real equilibrium.  For r > 1, there are three.  At r = 1, the three equilibria are all at the origin.  We examine the stability near r = 1.  
;[s]
2:0,1;37,0;208,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = {10.0,1.01,8/3};
:[font = input; preserveAspect; startGroup]
classify[C0]
:[font = print; inactive; preserveAspect; endGroup]
unstable
:[font = input; preserveAspect; startGroup]
classify[C1]
:[font = print; inactive; preserveAspect; endGroup]
strictly stable
:[font = input; preserveAspect; startGroup]
classify[C2]
:[font = print; inactive; preserveAspect; endGroup]
strictly stable
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C2]]
:[font = text; inactive; preserveAspect]
Thus the origin (C0) goes from stable to unstable at the bifurcation, and the two new equilibria are stable nodes, so we have a pitchfork bifurcation.  For r near 1, the new equilibria are close to the origin:
:[font = input; preserveAspect]
N[eqstateval[C1]]
:[font = input; preserveAspect]
N[eqstateval[C2]]
:[font = text; inactive; preserveAspect]
Here we have used the function eqstateval, which evaluates its argument by substituting current values of parmval for the symbols of parmvec.  
:[font = text; inactive; preserveAspect]
     The symmetry in x and y, showing in the eigenvalues and in the coordinates of the equilibria, is not accidental.  It is easy to show that the Lorenz equations are invariant to a simultaneous change of signs of x and y.  
:[font = text; inactive; preserveAspect]
The Node-Spiral Transition at r = 1.346.

     The next event along the r-trail is a change in character of the equilibria C1 and C2 from nodes to spirals.  As shown below, this occurs at about r = 1.346.  This is the first appearance of oscillatory behavior in the system as r increases from 0.
;[s]
2:0,1;42,0;296,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = {10.0,1.345,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = input; preserveAspect]
parmval = {10.0,1.347,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = text; inactive; preserveAspect]
     Let's look at a typical solution well into this oscillatory range.
:[font = input; preserveAspect]
parmval = {10.0, 10.0,8/3};
:[font = input; preserveAspect]
N[eqstateval[C1]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = input; preserveAspect]
initvec = {1,1,1};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 400;
:[font = input; preserveAspect]
sol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
graph1 = phaser3D[sol1];
:[font = text; inactive; preserveAspect]
     A nice spiral into the equilbrium C2.  Let's look at the x-y phase plane plot, followed by a plot of x versus time.
:[font = input; preserveAspect]
graph1xy = phaseplot[sol1,1,2];
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
graph1time = timeplot[sol1,1];
:[font = text; inactive; preserveAspect]
The Homoclinic Orbit at r = 13.926.

     For values of r < 13.926, the solution leaving the origin along the local unstable manifold spirals into the nearest of C1 and C2.  For values of r > 13.926, the solution leaving the origin loops around the nearer spiral equilibrium and then settles into the further one.  Let's verify that.  We begin by finding the local direction of the unstable manifold leaving the origin.
;[s]
2:0,1;37,0;420,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = {10.0, 12.0, 8/3};
:[font = input; preserveAspect]
eiger = Eigensystem[dermatval[C0]]
:[font = text; inactive; preserveAspect]
Now we take an initial condition slightly displaced from the origin, along the eigenvector of the unstable manifold.
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 600;
:[font = input; preserveAspect]
startvec = h*eiger[[2,2]]
:[font = input; preserveAspect]
sol2 = integrate[startvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph2 = phaser3D[sol2];
:[font = text; inactive; preserveAspect]
     We see that the solution leaving the origin spirals into the nearest equilibrium (C1 in this case).  Let's look at a 2D view -- in the xy phase plane.
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
graph2xy = phaseplot[sol2,1,2];
:[font = text; inactive; preserveAspect]
     Now we look at the same sequence of calculations for r = 16.
:[font = input; preserveAspect]
parmval = {10.0, 16.0, 8/3};
:[font = input; preserveAspect]
eiger2 = Eigensystem[dermatval[C0]]
:[font = input; preserveAspect]
startvec = h*eiger2[[2,2]]
:[font = input; preserveAspect]
sol3 = integrate[startvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph3 = phaser3D[sol3];
:[font = text; inactive; preserveAspect]
     Now the solution leaving the origin makes one loop around the nearest equilibrium (C1), and then travels to C2 where it spirals in.  The 2D view is given below.
:[font = input; preserveAspect]
graph3xy = phaseplot[sol3,1,2];
:[font = text; inactive; preserveAspect]
     What is the transition case between the two cases we have just looked at?  As numerical exploration has shown, the transition occurs for r = 13.926..., and the solution leaving the origin along the local unstable manifold returns to the origin along the local stable manifold (tangent to the z-axis).  It is hard to construct this homoclinic orbit numerically, because it is unstable.  We take an indirect approach, and look at a sequence of plots for a range of r values bracketing 13.926.  We construct the orbits using in each case an initial point displaced h from the origin along the local unstable manifold. 
:[font = input; preserveAspect]
initvec := h*Part[Part[Eigensystem[dermatval[C0]],2],2];
:[font = input; preserveAspect]
parmlist = {{10.0, 13.84, 8/3},{10.0, 13.88, 8/3},
			{10.0, 13.92, 8/3},{10.0, 13.96, 8/3},
			{10.0, 14.00, 8/3}}; 
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.01;
:[font = input; preserveAspect]
nsteps = 300;
:[font = input; preserveAspect]
plrange = {{-15,15},{0,25}};
:[font = input; preserveAspect]
Do[(parmval = parmlist[[q]];startvec = initvec;
	phaseplot[integrate[startvec,t0,h,nsteps],1,3]),
	{q,1,Length[parmlist]}]
:[font = text; inactive; preserveAspect]
     From these graphs, it is clear that somewhere between r = 13.92 and r = 13.96 there is a homoclinic orbit.  When r exceeds the value corresponding to the homoclinic orbit, there exists an unstable limit cycle, which is difficult to find numerically.    
:[font = text; inactive; preserveAspect]
     By symmetry, we get the mirror image of the above picture if we start on the other side of the origin.
:[font = text; inactive; preserveAspect]
The Range 13.926 < r < 24.06 and Pre-Chaotic Transients.
;[s]
1:0,1;57,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     The main event in this parameter range is the increasingly oscillatory nature of the solution as r increases.  For larger values of r in this range, some solutions go back and forth between C1 and C2 many times before spiraling into one of them.  These kinds of solutions are called pre-chaotic transients.  We will look at one of them shortly.
:[font = text; inactive; preserveAspect]
     The other event in this range (beyond our capabilities here to look at numerically) is the shrinking of the unstable limit cycles around C1 and C2.  The cycles are heading for a Hopf bifurcation which occurs at r = 24.74...  .
:[font = text; inactive; preserveAspect]
     We look at a pre-chaotic transient now.  This is a LONG integration, so it might be a good time for a coffee break.
:[font = input; preserveAspect]
parmval = {10.0,20.0,8/3};
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 2500;
:[font = input; preserveAspect]
initvec = {14.0,12.0,10.0};
:[font = input; preserveAspect]
chaotrans = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plrange = {{0,50},{-15,15}};
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
chaotranstimex = timeplot[chaotrans,1];
:[font = text; inactive; preserveAspect]
     We see eight zero crossings, meaning eight transitions between C1 and C2, with the system eventually settling into C2.  Now let's do this integration again with a smaller time step and the same final time.  (This will take TWICE as long as the above integration, so you can, if you prefer, just read the conclusion below the calculation.)
:[font = input; preserveAspect]
h = 0.01;
:[font = input; preserveAspect]
nsteps = 5000;
:[font = input; preserveAspect]
chaotrans2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
trans2timex = timeplot[chaotrans2,1];
:[font = text; inactive; preserveAspect]
    Now we have 19 transitions, and the system settling into C1 -- a different final state than before.  What a sobering example!  Halving the time step produced a completely different solution.  We don't even know the true final fate of the system -- does it go to C1 or C2?  The main lesson in these calculations is that these pre-chaotic transients share some properties with their even more difficult chaotic cousins.  Perhaps you would want to explore the question of whether we can overcome the uncertainty here with a sufficiently small time step.  
:[font = text; inactive; preserveAspect]
     Let's finish this off by looking at the 3D phase plane plot of this solution.  
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
plrange = Automatic;
:[font = input; preserveAspect]
transgraph3D = phaser3D[chaotrans2];
:[font = text; inactive; preserveAspect]
     This is starting to look a lot like the famous Lorenz chaotic attractor.
     
:[font = text; inactive; preserveAspect]
     At this point, you may be running into memory problems because of the many calculations.  If so, do the following:  (1) save this file; (2) quit Mathematica; (3) restart Mathematica and reload Parts 1 and 2 of the package; (4) reload this file; (5) start running this tutorial again from here.  To make that feasible, all of the basic system definitions are repeated below, and no values assigned previously or calculations made prior to this point are used below.  If you have enough memory to keep going without the restart, then you can just skip the system redefinitions below.
     
;[s]
1:0,1;593,-1;
2:0,13,10,Courier,5,12,0,0,0;1,13,10,Courier,3,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Re-Definition for Those Restarting Here.
;[s]
2:0,1;47,0;48,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = input; preserveAspect]
sysname = "Lorenz";
:[font = input; preserveAspect]
eqpoints = findpolyeq
:[font = input; preserveAspect]
C0 = eqpoints[[1]]
:[font = input; preserveAspect]
C1 = eqpoints[[2]]
:[font = input; preserveAspect]
C2 = eqpoints[[3]]
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = text; inactive; preserveAspect]
Point and Chaotic Attractors in 24.06 < r < 24.74.

     As r takes on values beyond 24.06, some of the pre-chaotic transients slip over the brink into true chaos.  Interestingly enough, the equilibria C1 and C2 remain stable for 24.06 < r < 24.74.  Thus in this small range, the system has both a chaotic attractor, and two stable spiral equilibria.  We will verify the nature of the equilibria, and then look at a few interesting orbits.     
;[s]
2:0,1;52,0;445,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = {10.0,24.4,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = input; preserveAspect]
Eigenvalues [dermatval[C1]]
:[font = input; preserveAspect]
parmval = {10.0,24.73,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]] 
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = input; preserveAspect]
parmval = {10.0,24.75,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = text; inactive; preserveAspect]
     The above calculations verify that the equilibria C1 and C2 are stable spirals until we reach r = 24.74, at which point they become unstable spirals.  Although the calculations of unstable limit cycles are beyond our capabilities here, it can be shown that in fact r = 24.74 is a subcritical Hopf bifurcation in which, as r is increased, the unstable limit cycles are absorbed by the equilibria which then become unstable themselves.  The character of the equilibrium at the origin is unchanged.  It remains a saddle with a one-dimensional unstable manifold.  
:[font = text; inactive; preserveAspect]
     We set an r value midway in this range, and see if we can find orbits leading to each of three attractors (by symmetry, we can just do one of C1 or C2).  For the spiral point attractor, we will cheat a little by starting very near the attractor, and then integrating backwards in time, to construct in that way an orbit which goes from some distant point to the attractor.  
:[font = input; preserveAspect]
parmval = {10.0,24.4,8/3};
:[font = input; preserveAspect]
N[eqstateval[C1]]
:[font = input; preserveAspect]
initvec = % + 0.001*{1,1,1}
:[font = input; preserveAspect]
h = -0.001;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
ranger = {{-30,30},{-30,30},{-50,50}};
:[font = input; preserveAspect]
plrange = ranger;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
ans1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graphans1 = phaser3D[ans1];
:[font = text; inactive; preserveAspect]
     Let's see where this solution went out of bounds.
:[font = input; preserveAspect]
First[ans1]
:[font = text; inactive; preserveAspect]
The x-coordinate went out of bounds.
:[font = text; inactive; preserveAspect]
     The stable spirals have eigenvalues with very small real parts.  The one large negative real eigenvalue tells us that the solutions rapidly approach the plane of the spiral, after which they slowly spiral in.  Let's try to observe at least part of the spiral by integrating forward in time, and magnifying our view.  For this direction in time, we can turn off range checking to speed up the integration.
:[font = input; preserveAspect]
rangeflag = False;
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
ans2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
staterange[ans2]
:[font = input; preserveAspect]
plrange = {{-7.92,-7.88},{-7.92,-7.88},{23.2,23.6}};
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
graphans2 = phaser3D[ans2];
:[font = text; inactive; preserveAspect]
A VERY slow spiral, which we could have predicted from the eigenvalues.
:[font = text; inactive; preserveAspect]
     Now we look for a chaotic solution.  We will use plots of x versus time to track our progress.  
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
initvec = {10,10,10};
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
cha1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
chagraph1 = timeplot[cha1,1];
:[font = text; inactive; preserveAspect]
We continue the integration.
:[font = input; preserveAspect]
cha2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
chagraph2 = timeplot[cha2,1];
:[font = text; inactive; preserveAspect]
One more time.
:[font = input; preserveAspect]
cha3 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
chagraph3 = timeplot[cha3,1];
:[font = text; inactive; preserveAspect]
At this point, we can be reasonably sure that this is a chaotic solution.  Let's combine our three pieces and make a phase plot.
:[font = input; preserveAspect]
bigcha = joinsol[cha1,joinsol[cha2,cha3]];
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
bigchagraph = phaser3D[bigcha];
:[font = text; inactive; preserveAspect]
Let's add to this picture our earlier orbit which reached the attractor at C1.
:[font = input; preserveAspect]
show3D[graphans1,bigchagraph];
:[font = text; inactive; preserveAspect]
     At this point, you may be running into memory problems because of the many calculations.  If so, do the following:  (1) save this file; (2) quit Mathematica; (3) restart Mathematica and reload Parts 1 and 2 of the package; (4) reload this file; (5) start running this tutorial again from here.  To make that feasible, all of the basic system definitions are repeated below, and no values assigned previously or calculations made prior to this point are used below.  If you have enough memory to keep going without the restart, then you can just skip the system redefinitions below.
     
;[s]
1:0,1;593,-1;
2:0,13,10,Courier,5,12,0,0,0;1,13,10,Courier,3,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Re-Definition for Those Restarting Here.
;[s]
2:0,1;47,0;48,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = input; preserveAspect]
sysname = "Lorenz";
:[font = input; preserveAspect]
eqpoints = findpolyeq
:[font = input; preserveAspect]
C0 = eqpoints[[1]]
:[font = input; preserveAspect]
C1 = eqpoints[[2]]
:[font = input; preserveAspect]
C2 = eqpoints[[3]]
:[font = text; inactive; preserveAspect]
Chaos (r = 28).

     We begin by resetting our plotting and integration defaults.  Then we set our parameter values and examine the three equilibrium points.   
;[s]
2:0,1;17,0;162,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
parmval = {10.0,28.0,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C2]]
:[font = text; inactive; preserveAspect]
     Now all three equilibrium points are unstable.  The system is bounded, so this raises the very interesting question of where it spends its time.  Of course there are other possible attractors such as limit cycles, but as discussed in the literature, there are strong arguments against the existence of stable limit cycles for this parameter range.  Whatever set the solutions live on must have zero volume.  This follows directly from Liouville's Theorem and the result
:[font = input; preserveAspect]
dival[slopevec] 
:[font = text; inactive; preserveAspect]
Thus volumes in phase space contract exponentially with an e-folding time of 1/13.6667.  The resolution of this puzzle came from the pioneering work of Lorenz.  The attractor in this case is a fractal set on which orbits wander forever.  We will content ourselves here with getting some two- and three-dimensional views of our numerical approximation to this fractal.  We start with a lengthy integration of 2000 points.
:[font = input; preserveAspect]
h = 0.015;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 2000;
:[font = input; preserveAspect]
fastflag = True;
:[font = input; preserveAspect]
initvec = {10,10,10};
:[font = input; preserveAspect]
lor1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
lorgraph1 = phaser3D[lor1];
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
lorgraph2 = phaseplot[lor1,1,2];
:[font = input; preserveAspect]
lorgraph3 = phaseplot[lor1,1,3];
:[font = input; preserveAspect]
lorgraph4 = phaseplot[lor1,2,3];
:[font = text; inactive; preserveAspect]
     At this point, you may be running into memory problems because of the many calculations.  If so, do the following:  (1) save this file; (2) quit Mathematica; (3) restart Mathematica and reload Parts 1 and 2 of the package; (4) reload this file; (5) start running this tutorial again from here.  To make that feasible, all of the basic system definitions are repeated below, and no values assigned previously or calculations made prior to this point are used below.  If you have enough memory to keep going without the restart, then you can just skip the system redefinitions below.
     
;[s]
1:0,1;593,-1;
2:0,13,10,Courier,5,12,0,0,0;1,13,10,Courier,3,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Re-Definition for Those Restarting Here.
;[s]
2:0,1;47,0;48,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = input; preserveAspect]
sysname = "Lorenz";
:[font = input; preserveAspect]
eqpoints = findpolyeq
:[font = input; preserveAspect]
C0 = eqpoints[[1]]
:[font = input; preserveAspect]
C1 = eqpoints[[2]]
:[font = input; preserveAspect]
C2 = eqpoints[[3]]
:[font = text; inactive; preserveAspect]
Some Large r Limit Cycles.
;[s]
2:0,1;26,0;27,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We have seen that as we increased r, chaos first appeared at r = 24.06, and by the time r = 24.74, it was the only possibility.  One might think that the larger r, the more chaotic the solution, but nonlinear sytems are full of surprises.  It turns out that there are narrow windows of large r values in which the solutions are not chaotic, and the attractor is a stable limit cycle!  We explore one such case here, namely r = 100.
:[font = input; preserveAspect]
parmval = {10.0,100.0,8/3};
:[font = text; inactive; preserveAspect]
Now we check the equilibrium states.
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = input; preserveAspect]
Eigenvalues[dermatval[C1]]
:[font = text; inactive; preserveAspect]
All three are unstable.  We begin an integration with a more or less arbitrary initial condition.
:[font = input; preserveAspect]
initvec = {10.0,10.0,10.0};
:[font = input; preserveAspect]
h = 0.01;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = input; preserveAspect]
lorlim = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
limgraph1 = phaser3D[lorlim];
:[font = text; inactive; preserveAspect]
Hard to tell if there is a limit cycle because of the transients.  We continue the integration to get a better idea.
:[font = input; preserveAspect]
lorlim2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
limgraph2 = phaser3D[lorlim2];
:[font = text; inactive; preserveAspect]
Now we clearly have a rather exotic-looking limit cycle.  We could clean it up a little by using a smaller time step and integrating once more, but the picture wouldn't change much.
:[font = text; inactive; preserveAspect]
Exercises
;[s]
2:0,1;9,0;10,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     In all the exercises below, use sigma = 10.0, b = 8/3.
     
:[font = text; inactive; preserveAspect]
(1) Study the phenomenon of sensitive dependence on initial conditions for chaotic solutions by plotting x versus t for two solutions of the Lorenz equations with slightly different initial conditions.  Do this for r = 28.    
:[font = text; inactive; preserveAspect]
(2) Use the routine animate to construct a sequence of rotated views of the chaotic Lorenz attractor for r = 28.  
:[font = text; inactive; preserveAspect]
(3)  Look for a stable limit cycle solution for r = 400.
:[font = text; inactive; preserveAspect; endGroup]
(4)  We noted earlier that the Lorenz equations are invariant to a simultaneous change of signs of x and y.  Does the limit cycle obtained above for r = 100 have this symmetry?  If not, find the second cycle implied by the symmetry.
^*)
