(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 3
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Equilibrium and Stability
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial
;[s]
1:0,1;46,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     classify, classify2D, dermat, dermatval, findpolyeq, nfindeq, nfindpolyeq, parmval, parmvec, residual, setparm, setstate, slopevec, and statevec.   
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     Two systems are studied here.  The first is a simple two-dimensional, linear, autonomous system depending on a single parameter.  Although such a system is easily analyzed "by hand," it also makes a good starting point for learning the routines in this package.  The second system analyzed is the Lorenz system.  In both cases we concentrate on locating equilibrium states, and finding whether they are stable or unstable. 
;[s]
2:0,1;46,0;475,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Reference 

     Almost every text on dynamical systems has material on the Lorenz equations.  A very accessible treatment is given in Chapter 9 of Nonlinear Dynamics and Chaos, S.H. Strogatz, Addison-Wesley, 1994.
;[s]
4:0,1;9,0;148,1;176,0;215,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition for 2D Linear System

     We denote the two state variables by x and y.  The system contains a single parameter, denoted by a.  
;[s]
2:0,1;40,0;148,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{a}];
:[font = input; preserveAspect]
slopevec = {a*y,-x-2*y};
:[font = input; preserveAspect]
parmval = {-3};
:[font = text; inactive; preserveAspect]
     This system has a single equilibrium point at x = y = 0 for all values of a.  For the special case a = 0, the coefficient matrix is singular, and there is an equilbrium line y = -x/2.  In a complete bifurcation study, we would characterize the system behavior for all values of a.  In particular, we would find the values for which the system makes major transitions.  Here we set the more limited goal of determining the nature of the equibrium for three values of a:  -3, 3/4, and 5.  
:[font = text; inactive; preserveAspect]
Equilibrium and Stability Using Classify

     The nature of the equilibrium point can be determined with the function classify, which takes the coordinates of the equilibrium point as an argument.
;[s]
2:0,1;42,0;198,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
classify[{0,0}]
:[font = text; inactive; preserveAspect]
We thus learn that the equilibrium is unstable.  We can get more information for a 2D system such as this by using classify2D.
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
Now we learn that the unstable equilibrium is a saddle point.
:[font = text; inactive; preserveAspect]
Equilibrium and Stability Using dermat

     The routines classify and classify2D are very useful in that they give us a quick answer.  However, they hide some details which are of interest.  Now we take a more hands-on approach to the determination of stability by finding the eigenvalues of the derivative matrix (which of course is exactly what classify does behind the scenes).  The function dermat returns the derivative matrix of the system.  The function dermatval[eqstate] returns the numerical derivative matrix evaluated at the equilibrium state and with parameter values taken from parmval.  
;[s]
2:0,1;40,0;604,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
dermat
:[font = input; preserveAspect]
dermatval[{0,0}]
:[font = text; inactive; preserveAspect]
The stability is determined by the eigenvalues of dermatval.  We use the built-in Mathematica function Eigenvalues to get these.     
;[s]
3:0,0;82,1;93,0;134,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = input; preserveAspect]
Eigenvalues[dermatval[{0,0}]]
:[font = text; inactive; preserveAspect]
We have two real eigenvalues, one positive and one negative, and thus this is a saddle point.
:[font = text; inactive; preserveAspect]
     Let's repeat this with less verbiage for the other two values of a.
:[font = input; preserveAspect]
parmval = {3/4};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
Eigenvalues[dermatval[{0,0}]]
:[font = text; inactive; preserveAspect]
Thus for a = 3/4, there are two negative real eigenvalues, and the equilibrium is a stable node.  For many purposes, it is useful to know the eigenvectors also, which we may easily get with the Mathematica command Eigenvectors.  Alternatively, we can get both eigenvalues and eigenvectors with the command Eigensystem.
;[s]
3:0,0;194,1;205,0;319,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = input; preserveAspect]
Eigenvectors[dermatval[{0,0}]]
:[font = input; preserveAspect]
Eigensystem[dermatval[{0,0}]]
:[font = text; inactive; preserveAspect]
     Now we look at the last value of a.
:[font = input; preserveAspect]
parmval = {5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
Eigenvalues[dermatval[{0,0}]]
:[font = text; inactive; preserveAspect]
Thus for a = 5, there are two complex conjugate eigenvalues with negative real parts, hence a stable spiral.
:[font = text; inactive; preserveAspect]
Summary of Stability for Linear Example

     We have shown that the equilibrium is unstable for a = -3, and stable for a = 3/4 and a = 5.  This is not very useful.  We really want to know the bifurcation point -- that is, the a-value at which the transition takes place between unstable and stable equilibrium.  For this simple problem, we can do that analytically by asking for the eigenvalues of the derivative matrix with a retained as a symbol rather than replaced as a number.  That is, we ask for the eigenvalues of dermat.
;[s]
2:0,1;41,0;531,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
Eigenvalues[dermat]
:[font = text; inactive; preserveAspect]
It is easy to show from this expression that the transition occurs at a = 0.  For a < 0, the equilibrium is unstable.  For a > 0, it is stable.  The transition a = 0 requires a special investigation, but by integrating the equations, it is easy to show that the equilibrium is unstable for a = 0. 
:[font = text; inactive; preserveAspect]
System Definition for Lorenz System

     We denote the three state variables by x, y, and z.  The system contains a three parameters, denoted by r, sigma and b.  
;[s]
2:0,1;37,0;164,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = text; inactive; preserveAspect]
We will make a fairly thorough study of this system in Tutorial 12.  For now, we just look at the equilibrium states for a few parameter values.
:[font = input; preserveAspect]
parmval1 = {10,0.5,8/3};
:[font = input; preserveAspect]
parmval2 = {10,1.1,8/3};
:[font = input; preserveAspect]
parmval3 = {10,10,8/3};
:[font = input; preserveAspect]
parmval4 = {10,30,8/3};
:[font = text; inactive; preserveAspect]
We start with parmval1.
:[font = input; preserveAspect]
parmval = parmval1;
:[font = text; inactive; noPageBreak; preserveAspect]
Equilibrium States
;[s]
2:0,1;18,0;19,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     There is the obvious equilibrium at the origin.  We will look for others.  We have three tools for this.  The routine findpolyeq will look for analytical expressions for the equilibria, provided the slope functions are polynomials.  The routine nfindpolyeq will look for numerical expressions for equilibria for polynomial slope functions.  The routine nfindeq[init] will take the initial guess init and look for a numerical root, using the Newton-Raphson method.  The routine nfindeq is not restricted to polynomials.
:[font = input; preserveAspect]
loroots = findpolyeq
:[font = text; inactive; preserveAspect]
We see that there are three roots.  For r < 1, only one of them is real, and for r > 1 all three are real.  We will name our three roots C0 (origin), C1, and C2.  We define them as parts of the above result.
:[font = input; preserveAspect]
C0 = loroots[[1]]
:[font = input; preserveAspect]
C1 = loroots[[2]]
:[font = input; preserveAspect]
C2 = loroots[[3]]
:[font = text; inactive; preserveAspect]
Stability of Equilibrium for r = 0.5

     The only relevant root for the values parmval1 is C0, because the others are not real.  We look at the stability of this equilibrium by using classify.
;[s]
2:0,1;38,0;195,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
classify[C0]
:[font = text; inactive; preserveAspect]
Let's look at the eigenvalues too.
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = text; inactive; preserveAspect]
We have already noted that two new roots appear at r = 1, and so we might suspect that is an important bifurcation.  Let's look at the stability of C0 for r = 1.
:[font = input; preserveAspect]
parmval = {10,1,8/3};
:[font = input; preserveAspect]
Eigenvalues[dermatval[C0]]
:[font = text; inactive; preserveAspect]
The zero eigenvalue signifies a bifurcation.
:[font = text; inactive; preserveAspect]
Stability of All Three Equilibria for r = 1.1.

     Let's move on to parmval2, for which r = 1.1.  We first find the numerical equilibrium positions.
;[s]
2:0,1;53,0;151,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = parmval2;
:[font = input; preserveAspect]
N[C0 /. Thread[parmvec -> parmval]]
:[font = input; preserveAspect]
N[C1 /. Thread[parmvec -> parmval]]
:[font = input; preserveAspect]
N[C2 /. Thread[parmvec -> parmval]]
:[font = text; inactive; preserveAspect]
We can also find these numerical values for the roots directly, by using nfindpolyeq.
:[font = input; preserveAspect]
nfindpolyeq
:[font = text; inactive; preserveAspect]
Still a third way to find the equilibrium points is with nfindeq, which uses the Newton-Raphson technique and requires an initial guess.  We can apply nfindeq again to the answer to get a better value of the root.  The accuracy can be checked by residual, which evaluates the slope at the root.  We do all of this for C2 to illustrate the techniques.
:[font = input; preserveAspect]
r1 = nfindeq[{0.4,0.4,0.0}]
:[font = input; preserveAspect]
residual[r1]
:[font = input; preserveAspect]
r2 = nfindeq[r1]
:[font = input; preserveAspect]
residual[r2]
:[font = text; inactive; preserveAspect]
The refinement produced by a second application of nfindeq wasn't necessary in this case to get good accuracy.
:[font = text; inactive; preserveAspect]
     Now we check the stability of all three equilibria.
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C0]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C1]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C2]]]
:[font = text; inactive; preserveAspect]
We see that C0 is unstable (saddle), and C2 and C3 are stable nodes.  Thus the bifurcation at r = 1 is a pitchfork bifurcation.  
:[font = text; inactive; preserveAspect]
     If we just want the conclusion for stability without the eigenvalues, we can use classify. 
:[font = input; preserveAspect]
classify[C0]
:[font = input; preserveAspect]
classify[C1]
:[font = input; preserveAspect]
classify[C2]
:[font = text; inactive; preserveAspect]
Stability of All Three Equilibria at r = 10.

     We go on to the next set of parameter values and examine the stability of each equilibrium point.
;[s]
2:0,1;46,0;149,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = parmval3;
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C0]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C1]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C2]]]
:[font = text; inactive; preserveAspect]
Thus C0 is still unstable (saddle), and C1 and C2 are now stable spirals.
:[font = text; inactive; preserveAspect]
Stability of All Three Equilibria at r = 30.

     We go on to the last set of parameter values and examine the stability of each equilbrium point.
;[s]
2:0,1;46,0;148,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
parmval = parmval4;
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C0]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C1]]]
:[font = input; preserveAspect]
N[Eigenvalues[dermatval[C2]]]
:[font = text; inactive; preserveAspect]
Now the spirals at C1 and C2 have become unstable, so that all three equilibria are unstable.  If none of the equilibria are stable, where does the system spend its time?  It turns out that this is a parameter set for which there are chaotic motions.  These will be explored in Tutorial 12.
:[font = text; inactive; preserveAspect]
Exercise
;[s]
2:0,1;8,0;9,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup]
     We have shown that for an r value of 10.0, the equilibria C1 and C2 are stable, and that for r = 30.0, they are unstable.  Find approximately the r value at which the transition occurs.   
^*)
