(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 4
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Local Solution
Near an Equilibrium Point
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial
;[s]
1:0,1;46,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     axon, classify2D, dermat, dermatval, integrate, parmval, parmvec, phaser, plrange, rangeflag, ranger, restoresys, savesys, setparm, setstate, slopevec, and statevec.   
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     We consider here a simple nonlinear, two-dimensional autonomous system with a single equilibrium point at the origin.  The equilibrium is a saddle with stable and unstable manifolds.  Our computations will illustrate the tangency connection between the manifolds for the linearized system and the full system.
;[s]
2:0,1;46,0;361,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We denote the two state variables by x and y.  The system contains no parameters, but we still define parmvec and parmval as empty lists, because a number of routines make use of these vectors behind the scenes.  
;[s]
2:0,1;19,0;238,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{}];
:[font = input; preserveAspect]
slopevec = {-x+y^2,x+y+x*y};
:[font = input; preserveAspect]
parmval = {};
:[font = input; preserveAspect]
sysname = "nlsystem";
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = text; inactive; preserveAspect]
Equilibrium Point
;[s]
2:0,1;17,0;18,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We start by analyzing the equilibrium at the origin.  We first use classify2D, but, because we will need the eigenvalues and eigenvectors later, we also carry out the more detailed analysis, by finding the matrix of the linearized system, which we call linmat, and finding its eigenvalues and eigenvectors.
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
linmat = dermatval[{0,0}]
:[font = input; preserveAspect]
Eigensystem[linmat]
:[font = text; inactive; preserveAspect]
Construction of Stable and Unstable Manifolds for Nonlinear System

     The stable manifold corresponds to the negative eigenvalue.  To construct it, we integrate backward in time, starting very near the equilibrium, displaced from the equilibrium along the eigenvector associated with the eigenvalue -1.  The solution going backward in time could grow very rapidly, so we avoid the possibility of overflow and crash by using range checking.  We limit the range to a box from -2 to 2 in both variables.
;[s]
2:0,1;68,0;504,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
ranger = {{-2,2},{-2,2}};
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = -0.02;
:[font = input; preserveAspect]
nsteps = 300;
:[font = input; preserveAspect]
initvec = 0.01*{-2,1};
:[font = input; preserveAspect]
stablesol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
initvec = -0.01*{-2,1};
:[font = input; preserveAspect]
stablesol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plrange = ranger;
:[font = input; preserveAspect]
graph1 = phaser[{stablesol1,stablesol2}];
:[font = text; inactive; preserveAspect]
     Now we use an entirely analogous procedure to construct the unstable manifold:  we start displaced slightly from the equilibrium along the eigenvector, and integrate forward in time.
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
initvec = 0.01*{0,1};
:[font = input; preserveAspect]
unstablesol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
initvec = -0.01*{0,1};
:[font = input; preserveAspect]
unstablesol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph2 = phaser[{unstablesol1,unstablesol2}];
:[font = text; inactive; preserveAspect]
     We combine these two graphs.
:[font = input; preserveAspect]
manifoldgraph = phaser[{stablesol1,stablesol2,
						unstablesol1,unstablesol2}];
:[font = text; inactive; preserveAspect]
Construction of Stable and Unstable Manifolds for Linearized System
;[s]
2:0,1;67,0;68,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     Now we construct the linearized system and then go through the same manifold constructions for it.  We first save the four vectors (statevec, slopevec, parmvec, and parmval) defining the original system, under the name nlsystem, and then we construct these vectors for the linearized system.
:[font = input; preserveAspect]
savesys[nlsystem]
:[font = text; inactive; preserveAspect]
     We continue to use {x,y} for the state vector, and both parmval and parmvec remain empty lists.  Thus for the linear system, we must redefine only the slope function.  It is the derivative matrix at equilibrium times the state vector.
:[font = input; preserveAspect]
slopevec = Dot[dermatval[{0,0}],{x,y}]
:[font = input; preserveAspect]
sysname = "linsystem";
:[font = text; inactive; preserveAspect]
     Now we construct the linear stable manifold.
:[font = input; preserveAspect]
ranger = {{-2,2},{-2,2}};
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = -0.02;
:[font = input; preserveAspect]
nsteps = 300;
:[font = input; preserveAspect]
initvec = 0.01*{-2,1};
:[font = input; preserveAspect]
linstablesol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
initvec = -0.01*{-2,1};
:[font = input; preserveAspect]
linstablesol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plrange = ranger;
:[font = input; preserveAspect]
lingraph1 = phaser[{linstablesol1,linstablesol2}];
:[font = text; inactive; preserveAspect]
     Now we construct the linear unstable manifold.
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
initvec = 0.01*{0,1};
:[font = input; preserveAspect]
linunstablesol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
initvec = -0.01*{0,1};
:[font = input; preserveAspect]
linunstablesol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
lingraph2 = phaser[{linunstablesol1,linunstablesol2}];
:[font = text; inactive; preserveAspect]
     The manifold is actually there, but it coincides with the y-axis.  We will make it visible in our next graph.  Now we show both the linear and nonlinear stable and unstable manifolds in the same graph.  We set axon = False to remove the axes for a better view.
:[font = input; preserveAspect]
axon = False;
:[font = input; preserveAspect]
lastgraph = show[{manifoldgraph,lingraph1,lingraph2}];
:[font = text; inactive; preserveAspect]
     This shows clearly how, at the equilibrium point, the manifolds of the linearized system are tangent to the manifolds of the nonlinear system.
:[font = text; inactive; preserveAspect]
     We now save the linearized system under the name linsystem, and restore the nonlinear system.
:[font = input; preserveAspect]
savesys[linsystem]
:[font = input; preserveAspect]
restoresys[nlsystem];
:[font = input; preserveAspect]
sysreport
:[font = text; inactive; preserveAspect]
Exercise
;[s]
2:0,1;8,0;9,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup]
     Repeat the above analysis for both equilibria of the system given by statevec = {x,y}, slopevec = {-x-y*y,y+x*x}. 
^*)
