(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 7
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Periodic Solutions
of
Driven Systems
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, display, drpoinclist, drpoincmap, drpoincmap3D, drpoincsol, integrate, intreset, lastt, lastx, modsol, parmval, parmvec, phaser, plot,  plotreset, plrange, poincpointper, poincptsize, pointcon, setparm, setstate, show, slopevec, staterange, statevec, sysname, timeplot, and trange.   
;[s]
2:0,1;47,0;345,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of System Used in This Tutorial

     We use the damped driven pendulum here to illustrate the routines for periodic solutions of periodically driven systems.  We construct solutions and Poincare maps for several different parameter sets -- some leading to periodic solutions, one leading to a chaotic solution.
;[s]
2:0,1;45,0;324,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Reference

     Although the driven pendulum is covered in many different texts, a particularly useful reference is Chaotic Dynamics, second edition, by G.L. Baker and J.P. Gollub, Cambridge Press, 1996.  The parameter values used here are taken from Chapter 3 of that reference.
;[s]
4:0,1;11,0;116,1;132,0;280,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We use the pendulum equation in dimensionless form, with the scaling such that the angular frequency of small amplitude, undamped, undriven oscillations is unity. We denote the dimensionless damping constant by eps. The driving function is f*Cos[w*t], where f is the dimensionless amplitude, and w is the dimensionless frequency.
;[s]
2:0,1;19,0;354,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{theta, omega}];
:[font = input; preserveAspect]
setparm[{eps,f,w}];
:[font = input; preserveAspect]
slopevec = {omega, -eps*omega -Sin[theta] + f*Cos[w*t]};
:[font = input; preserveAspect]
sysname = "Pendulum";
:[font = text; inactive; preserveAspect]
A Periodic Solution With Period Equal to Driver Period
;[s]
2:0,1;54,0;55,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We set the parameter values and then integrate.
:[font = input; preserveAspect]
parmval = {0.5,0.9,2/3};
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = input; preserveAspect]
initvec = {1.0,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
pen1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
pengraph1 = phaser[pen1];
:[font = text; inactive; preserveAspect]
     The system may have reached a periodic orbit, but we will have to integrate further to see.
:[font = input; preserveAspect]
pen2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
pengraph2 = phaser[pen2];
:[font = text; inactive; preserveAspect]
     This looks periodic.  Let's look at a time plot of the solution, and plot the driver on the same graph.
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
pengraphtime2 = timeplot[pen2,1];
:[font = input; preserveAspect]
driver[t_] := N[f*Cos[w*t] /. Thread[parmvec -> parmval]]
:[font = input; preserveAspect]
drivergraph = plot[driver[t],{t,50,100}];
:[font = input; preserveAspect]
show[pengraphtime2,drivergraph];
:[font = text; inactive; preserveAspect]
     We see from the graph that the solution is periodic with the same period as the driver, the period being
:[font = input; preserveAspect]
driverperiod = N[(2 Pi)/(2/3)]
:[font = text; inactive; preserveAspect]
     Let's construct a Poincare map showing both the approach and the final periodic solution.  We begin by constructing an appropriate solution list with drpoinclist.
:[font = input; preserveAspect]
pen3 = drpoincsol[initvec,t0,driverperiod,20];
:[font = text; inactive; preserveAspect]
The arguments of drpoinclist are the initial condition initvec, the initial time t0, the strobe period driverperiod, and the number of periods 20. 
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
pengraph3 = phaser[pen3];
:[font = text; inactive; preserveAspect]
     This graph is very similar to pengraph1 because it was constructed in essentially the same way.  The only significant difference between an arbitrary solution list and one constructed by poinclist, is that the time spacing in poinclist is commensurate with the strobe period, and the number of integration points per period is equal to the value of pointper (the default is 48 points per period).  
     
     The Poincare map is now constructed from pen3 by the routine drpoincmap.  The second argument of drpoincmap is the phase (in degrees) at which the map is to be made.  This may be any multiple of 15 degrees from 0 to 345.  
:[font = input; preserveAspect]
poincptsize = 0.02;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
phase = 0.0;
:[font = input; preserveAspect]
poincgr3 = drpoincmap[pen3,phase,1,2];
:[font = text; inactive; preserveAspect]
     The list of coordinates plotted in the Poincare map may be obtained with the function drpoinclist acting on the solution pen3.
:[font = input; preserveAspect]
poincerlist3 = drpoinclist[pen3,phase]
:[font = text; inactive; preserveAspect]
     We see from this that the approach to the periodic solution is rapid.  By the fourth strobe period, the system point has settled down to the final one, within graphical accuracy.  This is consistent with the graph, on which we see four points only.
:[font = text; inactive; preserveAspect]
Solution Period Equal to Twice the Driver Period
;[s]
1:0,1;49,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We consider another set of parameter values for which the response is periodic with twice the period of the driver.  In this example, we start with drpoinclist, rather than doing a preliminary integration first.  We go 10 periods at a time. 
:[font = input; preserveAspect]
parmval = {0.5,1.07,2/3};
:[font = input; preserveAspect]
initvec = {8.0,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
pen5 = drpoincsol[initvec,t0,driverperiod,10];
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
pengraph5 = phaser[pen5];
:[font = text; inactive; preserveAspect]
     It looks as though we may have reached a periodic solution.  We continue the integration, to get a pure periodic solution without the startup transient.
:[font = input; preserveAspect]
pen6 = drpoincsol[lastx,lastt,driverperiod,10];
:[font = input; preserveAspect]
pengraph6 = phaser[pen6];
:[font = text; inactive; preserveAspect]
     This appears to be periodic with a period of twice the driver period.  We check that with a timeplot.
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
plrange = All;
:[font = input; preserveAspect]
display = False;
:[font = input; preserveAspect]
pengraph7 = timeplot[pen6,1];
:[font = input; preserveAspect]
trange[pen6]
:[font = input; preserveAspect]
driver2 = plot[driver[t], {t,100,210}];
:[font = input; preserveAspect]
show[pengraph7,driver2];
:[font = text; inactive; preserveAspect]
A close look shows that indeed the solution repeats every second period of the driver.
:[font = text; inactive; preserveAspect]
     Now we construct the Poincare map.  Because we are strobing at the driver period and because the solution has a period twice this, we expect to see exactly two dots on the Poincare plot.
:[font = input; preserveAspect]
display = True;
:[font = input; preserveAspect]
poincptsize = 0.02;
:[font = input; preserveAspect]
phase = 0.0;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{2,10},{-3,3}};
:[font = input; preserveAspect]
poincgr6 = drpoincmap[pen6,phase,1,2];
:[font = text; inactive; preserveAspect]
     We see the two dots, indicative of the subharmonic of order two.
:[font = text; inactive; preserveAspect]
Rotary Solution With Period Equal to Driver Period
;[s]
1:0,1;51,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     Now we look at a periodic solution in which the pendulum rotates over the top in each cycle.  The coordinate theta increases without limit.  We will use the function modsol to frame the solution in a single 2 Pi range of theta.  We begin by resetting integration flags and plot variables, and then setting the parameter values.
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
parmval = {0.5,1.35,2/3};
:[font = text; inactive; preserveAspect]
     We start with a 500 point integration to get onto the periodic solution.
:[font = input; preserveAspect]
initvec = {0,0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 500;
:[font = input; preserveAspect]
oversol1 = integrate[initvec,t0,h,nsteps];
:[font = text; inactive; preserveAspect]
     We check the range before plotting.
:[font = input; preserveAspect]
staterange[oversol1]
:[font = input; preserveAspect]
plrange = {{-20,5},{-2,2}};
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
overgraph1 = phaser[oversol1];
:[font = text; inactive; preserveAspect]
     We continue the integration to get the pure periodic solution.
:[font = input; preserveAspect]
oversol2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
staterange[oversol2]
:[font = input; preserveAspect]
plrange = {{-40,-10},{-2,2}};
:[font = input; preserveAspect]
overgraph2 = phaser[oversol2];
:[font = text; inactive; preserveAspect]
     This looks periodic.  (A minor mathematical point.  Strictly speaking the solution is not periodic because the theta values do not repeat.  However, theta values differing by 2 Pi represent the same physical point.  If points differing by 2 Pi are considered to be the same, then the solution is periodic.)  There are two practical difficulties.  First, the solution will keep drifting to the left, and we will have to keep changing our phase plane window if we wish to follow it.  Second, it is hard to tell periodicity because the loops do not overlay as they do in the case when the pendulum oscillates rather than going around.  We can cure both of those difficulties by using modsol, a function which maps any coordinate onto a specified interval modulo the interval length.  Here we use the interval -Pi to Pi, and we ask for the first component (theta) to be so mapped.
:[font = input; preserveAspect]
modsol1 = modsol[oversol1,1,N[-Pi],N[Pi]];
:[font = text; inactive; preserveAspect]
     Now we plot the modified solution.  We use dots rather than a connected line, so that we avoid connecting lines at the jumps at the interval ends.
:[font = input; preserveAspect]
pointcon = False;
:[font = input; preserveAspect]
plrange = {{-4,4},{-2,2}};
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
modgraph1 = phaser[modsol1];
:[font = text; inactive; preserveAspect]
     We repeat for the pure periodic solution oversol2.
:[font = input; preserveAspect]
modgraph2 = phaser[modsol[oversol2,1,N[-Pi],N[Pi]]];
:[font = text; inactive; preserveAspect]
     The solution looks periodic, but the slight thickening suggests that there is a small residual of a transient.  We integrate once more to clean it up.
:[font = input; preserveAspect]
oversol3 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
modgraph3 = phaser[modsol[oversol3,1,N[-Pi],N[Pi]]];
:[font = text; inactive; preserveAspect]
     Now we have a clean periodic solution.
:[font = text; inactive; preserveAspect]
A Chaotic Solution
;[s]
2:0,1;18,0;19,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We complete our look at the driven pendulum with a chaotic solution.  We start by setting the parameter values, and resetting the integration flags and plot variables.
:[font = input; preserveAspect]
parmval = {0.5,1.5,2/3};
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = text; inactive; preserveAspect]
     We start with a 500-point integration just to see what the solution looks like.
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 500;
:[font = input; preserveAspect]
initvec = {1,0};
:[font = input; preserveAspect]
cha1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
staterange[cha1]
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-10,2},{-3,3}};
:[font = input; preserveAspect]
chagraph1 = phaser[cha1];
:[font = text; inactive; preserveAspect]
     Too early to tell if it is chaotic, although it might be.  We do next a very long integration, using poinclist, and then look at the results.  We reduce the number of points per period from 48 to 24, just to halve the integration time.  The 200 periods asked for below takes a LONG time to calculate, and the basic ideas would still come through with a much smaller number of periods -- say 30.  On the other hand, the Poincare maps get more interesting with more periods.  If you have enough memory and time, try 600 or even more periods.
:[font = input; preserveAspect]
poincpointper = 24;
:[font = input; preserveAspect]
poinchao = drpoincsol[lastx,lastt,driverperiod,200];
:[font = input; preserveAspect]
staterange[poinchao]
:[font = text; inactive; preserveAspect]
     The large theta range shows that we need to use modsol to get a more compact description.
:[font = input; preserveAspect]
poinchaomod = modsol[poinchao,1,N[-Pi],N[Pi]];
:[font = text; inactive; preserveAspect]
     Now we write a simple loop to produce a sequence of Poincare maps for each of the allowable phases -- that is, a sequence of 24 maps at 15 degree phase intervals.
:[font = input; preserveAspect]
plrange = {{-4,4},{-4,4}};
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
Do[(drpoincmap[poinchaomod,q,1,2]),{q,0,345,15}];
:[font = text; inactive; preserveAspect]
     An animation of the 24 graphs gives some insight into the variation of the Poincare map with phase.
:[font = text; inactive; preserveAspect]
A Three-Dimensional Driven Solution
;[s]
2:0,1;35,0;36,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     To illustrate the use of the Poincare map for 3D driven systems, we consider a simple but somewhat artificial extension of the pendulum into three dimensions, by adding a z-coordinate which simply decays with time to the plane z = 0.  We start by defining the system.
:[font = input; preserveAspect]
setstate[{theta,omega,z}];
:[font = input; preserveAspect]
setparm[{eps,f,w}];
:[font = input; preserveAspect]
slopevec = {omega, -eps*omega -Sin[theta] + f*Cos[w*t],-0.05*z};
:[font = input; preserveAspect]
sysname = "Pendulum3D";
:[font = text; inactive; preserveAspect]
     We choose the parameter values that in the 2D case gave us an oscillatory solution with period equal to the driver period.  
:[font = input; preserveAspect]
parmval = {0.5,0.9,2/3};
:[font = input; preserveAspect]
sysreport
:[font = text; inactive; preserveAspect]
     We start above the plane z = 0.  We will make a Poincare map of the approach to a periodic solution.
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
driverperiod = N[(2 Pi)/(2/3)];
:[font = input; preserveAspect]
initvec = {1.0,0.0,2.0};
:[font = input; preserveAspect]
penpoinc3D = drpoincsol[initvec,t0,driverperiod,20];
:[font = text; inactive; preserveAspect]
     Now we construct the Poincare map for this solution, at zero phase.
:[font = input; preserveAspect]
phase = 0.0;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plrange = {{-2,2},{-4,4},{0,2}};
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
poincptsize = 0.02;
:[font = input; preserveAspect]
viewpt = {2,-24,10}; 
:[font = input; preserveAspect]
graphpoinc3d = drpoincmap3D[penpoinc3D,phase,1,2,3];
:[font = text; inactive; preserveAspect]
     It is helpful to view a projection of this map on the theta-omega plane.
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-2,2},{-4,4}};
:[font = input; preserveAspect]
graphpoinc2D = drpoincmap[penpoinc3D,phase,1,2];
:[font = text; inactive; preserveAspect]
     Let's look at the coordinates in the Poincare map. 
:[font = input; preserveAspect]
drpoinclist[penpoinc3D,phase]
:[font = text; inactive; preserveAspect]
     From here we see that the eventual periodic point in the map is at theta = -0.560, omega = 1.934.
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Consider again the two-dimensional rotary solution with period equal to the driver period, for the parameter values parmval = {0.5,1,35,2/3}.  By experimenting with initial conditions, find a second rotary solution in the opposite sense, with the same parameter values.
;[s]
2:0,1;10,0;285,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
