(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 8
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Orbit Trapping
and
Index Theory
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     classify2D, dirfield, display, index, limcyc, orbcross,  parmval, parmvec, period, phaser, plotcurve, plotreset, plrange, setparm, setstate, show, slopevec, statevec, and sysid.   
;[s]
2:0,1;47,0;233,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of System Used in This Tutorial

     The functions illustrated here are for two-dimensional systems.  As examples, we use several simple linear and nonlinear systems.  We show how to define curves, how to determine whether a curve traps orbits, and how to find the index of a closed curve with respect to a given system.  
;[s]
2:0,1;45,0;336,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
How to Define a Curve

     As described in detail in Section 2, a curve is a collection of connected smooth arcs.  We define each arc parametrically, and then we define the curve as the union.  We carry that procedure out here, and we plot the curve at each stage of construction.  The curve we construct is a quarter-circle with center at {x0,y0} and radius r0.  We begin by defining arc1, the arc of the quarter circle.
;[s]
2:0,1;23,0;423,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
arc1 = {{x0+r0*Cos[u],y0+r0*Sin[u]},{u,0,N[Pi/2]}};
:[font = text; inactive; preserveAspect]
The first part of the expression gives x and y in terms of the parameter u.  The second part of the expression gives the name of the parameter and its range.  In order to use this, we must assign numerical values to x0, y0, and r0.
:[font = input; preserveAspect]
x0 = 1.0; y0 = 1.0; r0 = 2.0; 
:[font = text; inactive; preserveAspect]
The object arc1 is an arc.  A curve is a list of arcs, which, as a special case, can be a single arc.  Thus to make arc1 a curve, named firstcurve, we type
:[font = input; preserveAspect]
firstcurve = {arc1};
:[font = text; inactive; preserveAspect]
Let's plot this curve.  We set plrange, and then we use the function plotcurve to plot it.  Even though arc1 is not specifically connected with any differential equation, we must define state vector before plotting, because it is used for labels of the plot axes.
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plrange = {{0,4},{0,4}};
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
graph1 = plotcurve[firstcurve];
:[font = text; inactive; preserveAspect]
     Now we continue to build our curve by defining an arc which is a straight line dropping down to the quarter-circle center.
:[font = input; preserveAspect]
arc2 = {{x0,y0+r0*(1-u)},{u,0,1}};
:[font = text; inactive; preserveAspect]
We re-define our curve to include this and plot it again.
:[font = input; preserveAspect]
firstcurve = {arc1,arc2};
:[font = input; preserveAspect]
graph2 = plotcurve[firstcurve];
:[font = text; inactive; preserveAspect]
     We add one last piece to make it a closed curve.
:[font = input; preserveAspect]
arc3 = {{x0+r0*u,y0},{u,0,1}};
:[font = input; preserveAspect]
firstcurve = {arc1,arc2,arc3};
:[font = input; preserveAspect]
graph3 = plotcurve[firstcurve];
:[font = text; inactive; preserveAspect]
     To continue this exercise in defining curves, we define a family of circles which will be used in an orbit-trapping example below.  These are circles with center at the origin and a radius rad which we may vary.  Note the extra curly brackets around the definition to convert the arc to a curve.
:[font = input; preserveAspect]
trappercurve[rad_]:= {{{rad*Cos[u],rad*Sin[u]},{u,0,N[2*Pi]}}};
:[font = text; inactive; preserveAspect]
We plot two of these on the same graph.
:[font = input; preserveAspect]
display = False;
:[font = input; preserveAspect]
circin = plotcurve[trappercurve[0.75]];
:[font = input; preserveAspect]
circout = plotcurve[trappercurve[5.0]];
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5}};
:[font = input; preserveAspect]
graph4 = show[circin,circout];
:[font = text; inactive; preserveAspect]
Trapping a Limit Cycle
;[s]
2:0,1;22,0;23,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     Now we illustrate an application of the Poincar-Bendixson theorem by trapping a limit cycle.  We first define our system, a two-dimensional polynomial nonlinear system.
:[font = input; preserveAspect]
setstate[{x,y}]; 
:[font = input; preserveAspect]
setparm[{}];
:[font = input; preserveAspect]
slopevec = {y-x*(x^2+y^2-2*x-3),-x-y*(x^2+y^2-2*x-3)};
:[font = input; preserveAspect]
parmval = {};
:[font = text; inactive; preserveAspect]
     We now ask whether orbits are trapped by either of our two circles.
:[font = input; preserveAspect]
orbcross[trappercurve[0.75]]
:[font = text; inactive; preserveAspect]
We see that the crossings are all in the positive N direction which is outward (the closed curve is positively oriented).  Now we check the outer curve.
:[font = input; preserveAspect]
orbcross[trappercurve[5.0]]
:[font = text; inactive; preserveAspect]
Now the crossings are all in the negative N direction.  Thus no orbit can leave the region bounded by the two circles.  The Poincar-Bendixson theorem says that either there is an equilibrium point or a periodic solution inside.  A little algebra shows that the only equilibrium point for this system is at the origin, so we conclude that there must be a periodic solution inside.  Can we bound it more closely?  Let's try.
:[font = input; preserveAspect]
orbcross[trappercurve[1.0]]
:[font = text; inactive; preserveAspect]
Now we have a tangency, so we are probably at the limit for the inner curve.  We can verify that by trying rad = 1.1.
:[font = input; preserveAspect]
orbcross[trappercurve[1.1]]
:[font = text; inactive; preserveAspect]
Now we get crossings in both directions.  So rad = 1.0 is the best we can do for the inner boundary with this family of curves.  
:[font = text; inactive; preserveAspect]
     Now let's try to move the outer boundary in.
:[font = input; preserveAspect]
orbcross[trappercurve[4.0]]
:[font = input; preserveAspect]
orbcross[trappercurve[3.0]]
:[font = text; inactive; preserveAspect]
We are at the limit.  The best statement we can make with this family of circles is that there is a periodic solution in the range 1.0 <= rad <= 3.0.
:[font = text; inactive; preserveAspect]
     Let's plot the direction field for this system and display it with our two optimal bounding circles.
:[font = input; preserveAspect]
plrange = {{-3,3},{-3,3}};
:[font = input; preserveAspect]
graph5 = dirfield;
:[font = input; preserveAspect]
graph6 = plotcurve[trappercurve[1.0]];
:[font = input; preserveAspect]
graph7 = plotcurve[trappercurve[3.0]];
:[font = input; preserveAspect]
graph8 = show[graph5,graph6,graph7];
:[font = text; inactive; preserveAspect]
     The Poincar-Bendixson theorem says there is at least one periodic solution in this region.  As the computer shows, there is exactly one -- a limit cycle.  Let's construct it and add it to the picture. 
:[font = input; preserveAspect]
initvec = {2.0,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
persol = limcyc[initvec,t0,h,nsteps];
:[font = input; preserveAspect; startGroup]
period[persol]
:[font = output; output; inactive; preserveAspect; endGroup]
6.300000000000000022
;[o]
6.3
:[font = input; preserveAspect]
graph9 = phaser[persol];
:[font = input; preserveAspect]
show[graph6,graph7,graph9];
:[font = text; inactive; preserveAspect]
     We see clearly how the limit cycle is trapped by the two circles, and that it is tangent to both. 
:[font = text; inactive; preserveAspect]
Index Theory
;[s]
2:0,1;12,0;13,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     The index of a closed curve with respect to a vector field is the number of full rotations of the vector fields as the curve is traversed.  The usefulness of the concept is based on part on several theorems.  The first is that the index of a periodic solution is always 1.  The second is that the index of a curve enclosing a finite number isolated equilibrium points, all of which are elementary (i.e., the determinant of the derivative matrix is nonzero), is given by I = (number of nodes) + (number of spirals) + (number of centers) - (number of saddles).  Combining these two theorems leads to the interesting statements that one a periodic solution must enclose at least one equilibrium, and if it encloses only one elementary equilibrium and no others, that one cannot be a saddle.  
:[font = text; inactive; preserveAspect]
     We will illustrate these ideas by a few simple calculations, using the routine index[curve] which calculates the index for curve.  
:[font = text; inactive; preserveAspect]
     In the above trapping calculation, the two trapping circles contain no equilibria between them.  Therefore they should have the same index.  Because the periodic solution must have index 1, we conclude by the same reasoning that each of the trapping curves must have index 1.  Let's verify this.
:[font = input; preserveAspect]
index[trappercurve[1.0]]
:[font = input; preserveAspect]
index[trappercurve[5.0]]
:[font = text; inactive; preserveAspect]
     Now let's verify the theorem on the relation between the index and the nature of the enclosed equilibria.  We do this for a very simple linear system with a single parameter.
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{alpha}];
:[font = input; preserveAspect]
slopevec = {alpha*y,-x-2*y};
:[font = text; inactive; preserveAspect]
This system has a single equilibrium point at the origin, and the character of the equilibrium depends on the value of the parameter a.  We will take as our test curve the unit circle.
:[font = input; preserveAspect]
unitarc = {{Cos[u],Sin[u]},{u,0,N[2*Pi]}};
:[font = input; preserveAspect]
unitcurve = {unitarc};
:[font = input; preserveAspect]
parmval = {-1};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
With a saddle, we expect to get an index of -1.
:[font = input; preserveAspect]
index[unitcurve]
:[font = text; inactive; preserveAspect]
So far so good.  Now we set a = 0.5.
:[font = input; preserveAspect]
parmval = {0.5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
This should give an index of 1.
:[font = input; preserveAspect]
index[unitcurve]
:[font = text; inactive; preserveAspect]
Now set a = 2.0.
:[font = input; preserveAspect]
parmval = {2.0};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
index[unitcurve]
:[font = text; inactive; preserveAspect]
     The index does not depend on the stability of the equilibrium.  We can verify that for this case by reversing the sign of the slope vector (effectively reversing time), and turning our stable node and spiral into unstable ones.
:[font = input; preserveAspect]
slopevec = -slopevec;
:[font = input; preserveAspect]
parmval = {0.5};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
index[unitcurve]
:[font = input; preserveAspect]
parmval = {2.0};
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = input; preserveAspect]
index[unitcurve]
:[font = text; inactive; preserveAspect]
Exercise
;[s]
2:0,1;8,0;9,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup]
     Construct a linear system with an equilibrium which is a center, and verify that the index for any enclosing curve is 1.  Construct a system with several equilibria, and verify the index theorem for a curve enclosing all of them.
^*)
