(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 9
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Phase Portraits
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, boxrat, display, integrate, intreset, limcyc,  parmval, parmvec, period, phaser, phaseseq, phaseseq3D, plotreset, plrange, portrait, portrait3D, restoresys, savesys, setparm, setstate, show, slopevec, statevec, sysid, and sysreport.   
;[s]
2:0,1;47,0;296,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of System Used in This Tutorial

     In this tutorial, we illustrate the production of phase portraits from a given set of initial conditions.  We also show how to construct a sequence of graphs which, when animated, gives a dynamic view of the orbits in time.  For a two-dimensional example, we use the van der Pol equation.  For a three-dimensional example, we use the van der Pol equation embedded in a three-dimensional system.   
;[s]
2:0,1;45,0;448,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     There are many graphs in this tutorial.  You may need to delete some or all of the graphs created in the first part before running the second part, unless you have a lot of memory allotted to your Mathematica Front End.
;[s]
3:0,0;202,1;213,0;225,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
Reference

     The van der Pol system is discussed in most texts on dynamical systems.  For a brief introduction, see Chapter 7 of Nonlinear Dynamical Systems and Chaos, S.H. Strogatz, Addison-Wesley, 1994.
;[s]
4:0,1;11,0;132,1;169,0;208,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition
;[s]
2:0,1;17,0;18,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We define both systems here.  First the 2D van der Pol.
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{mu}];
:[font = input; preserveAspect]
slopevec = {y, -x -mu*(x*x-1)*y};
:[font = input; preserveAspect]
parmval = {1};
:[font = input; preserveAspect]
savesys[van2D];
:[font = text; inactive; preserveAspect]
Now the three dimensional version.  This is defined so that all orbits starting off z = 0 approach z = 0, and the van der Pol limit cycle is in the x-y plane.
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{mu}];
:[font = input; preserveAspect]
slopevec = {y, -x -mu*(x*x-1)*y,-z};
:[font = input; preserveAspect]
parmval = {1};
:[font = input; preserveAspect]
savesys[van3D];
:[font = text; inactive; preserveAspect]
Phase Portrait for 2D van der Pol

     We are going to construct, on a modest scale, a phase portrait for the van der Pol limit cycle.  The portrait will show how a few selected initial conditions, starting inside the cycle,  reach the limit cycle.  We will first do this by the tools we already have, and then we will repeat the calculation using the function portrait, which automates the process somewhat.
;[s]
2:0,1;35,0;410,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
restoresys[van2D];
:[font = input; preserveAspect]
sysreport
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
nsteps = 600;
:[font = input; preserveAspect]
initvec = {1,0};
:[font = text; inactive; preserveAspect]
     We begin by constructing the limit cycle.  Then we will construct the transient approaches.
:[font = input; preserveAspect]
sol0 = limcyc[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph0 = phaser[sol0];
:[font = input; preserveAspect]
period[sol0]
:[font = text; inactive; preserveAspect]
     Now we construct four orbits showing transient approach to the limit cycle.
:[font = input; preserveAspect]
sol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-3,3},{-3,3}};
:[font = input; preserveAspect]
display = False;
:[font = input; preserveAspect]
graph1 = phaser[sol1];
:[font = input; preserveAspect]
initvec = {0,1};
:[font = input; preserveAspect]
sol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph2 = phaser[sol2];
:[font = input; preserveAspect]
initvec = {-1,0};
:[font = input; preserveAspect]
sol3 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph3 = phaser[sol3];
:[font = input; preserveAspect]
initvec = {0,-1};
:[font = input; preserveAspect]
sol4 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph4 = phaser[sol4];
:[font = input; preserveAspect]
display = True;
:[font = input; preserveAspect]
show[graph1,graph2,graph3,graph4];
:[font = text; inactive; preserveAspect]
     Now we produce the same graph with a single command, portrait.  The first argument of portrait is the list of initial conditions to be used.  The next three arguments are exactly the same as the last three of integrate, and the last two arguments are the indices of the components to be plotted. 
:[font = input; preserveAspect]
intlist = {{1,0},{0,1},{-1,0},{0,-1}};
:[font = input; preserveAspect]
port1 = portrait[intlist,t0,h,nsteps,1,2];
:[font = text; inactive; preserveAspect]
     The advantage of portrait is that once you have decided (usually as the result of some experimental integrations) which initial conditions to use, and what time step and the number of steps, you can perform a lengthy final construction in an unattended mode by using portrait.
:[font = text; inactive; preserveAspect]
Dynamic Orbits for 2D van der Pol

     We now show how to construct a sequence of graphs which, when animated, will simulate the travel of the phase point in time around the orbit.  To keep the picture relatively uncluttered, we construct only two such orbits.  The routine that does this construction is phaseseq.  Phaseseq has the following arguments:  a list of initial conditions, initlist; the initial time, t0; the time step, h; the number of time steps per incremental picture, nstepic; the number of pictures, npics; the indices of the components to be plotted.  
;[s]
2:0,1;35,0;573,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     The numbers below have been selected so that we get 26 pictures, at equal time increments, which trace exactly one period of the limit cycle.  We use two initial conditions on the cycle (taken from sol0), on opposite sides.  After the calculation is complete, you should group the 26 pictures together (the command Closed Group in the Cell Menu), and then animate them (the command Animate Selected Graphics in the Graph Menu).  The animation will show the production of the limit cycle from the given initial condtions, followed by the two phase points moving around the cycle.  If you want to see just the steady-state motion around the limit cycle, just select the only the last half of the graphs and then animate that selection.  If you have time and memory enough, try this with many more pictures and a smaller time interval per picture.   
:[font = input; preserveAspect]
initlist = {{-2.00818,-0.0431826},{2.00607,0.106488}};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.031827;
:[font = input; preserveAspect]
nstepic = 8;
:[font = input; preserveAspect]
npics = 26;
:[font = input; preserveAspect]
dyngraph = phaseseq[initlist,t0,h,nstepic,npics,1,2];
:[font = text; inactive; preserveAspect; animationSpeed = 5]
Phase Portrait for 3D van der Pol

     In this case, orbits starting off the plane z = 0 decay exponentially to z = 0.  The projection of the orbits in the x-y plane are identical to the orbits of the 2D system.  We construct a phase portrait for two different initial conditions, both starting at z = 3. 
;[s]
2:0,1;35,0;307,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
restoresys[van3D];
:[font = input; preserveAspect]
sysreport
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plrange = {{-4,4},{-4,4},{0,4}};
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
intlist = {{3,3,3},{-3,-3,3}};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 600;
:[font = input; preserveAspect]
port3D = portrait3D[intlist,t0,h,nsteps,1,2,3];
:[font = text; inactive; preserveAspect]
Dynamic Orbit for 3D van der Pol

     As our last calculation in this tutorial, we construct a dynamic view of an orbit starting at {1,0,3}.  The projection of this orbit in the x-y plane will spiral outward toward the limit cycle.  At the same time, the orbit decays exponentially in z from 3 to 0.
;[s]
2:0,1;34,0;301,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intlist = {1,0,3};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nstepic = 12;
:[font = input; preserveAspect]
npics = 25;
:[font = input; preserveAspect]
plrange = {{-3,3},{-3,3},{0,3}};
:[font = input; preserveAspect]
dyngraph3D = phaseseq3D[intlist,t0,h,nstepic,npics,1,2,3];
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Construct a phase portrait and a dynamical orbit sequence for the system given by statevec = {x,y,z}, parmvec = {eps}, parmval = {0.2}, slopevec = {y,-x - 2.0*eps*y,-z}.
;[s]
2:0,1;10,0;185,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
